#############################################################################
# ___  __.                                             __                   #
#|   |/ _|______   ____  ____   ____      ____   _____/  |_  _______ __ __  #
#|     < \_  __ \_/ __ \/  _ \ /    \    /    \_/ __ \   __\ \_  __ \  |  \ #
#|   |  \ |  | \/\  ___(  <_> )   |  \  |   |  \  ___/|  |    |  | \/  |  / #
#|___|__ \|__|    \___  >____/|___|  / /\___|  /\___  >__|   /\__|  |____/  #
#       \/            \/           \/  \/    \/     \/       \/             #
#                              D i g i t a l   S i d e   o f   L i f e      #
#############################################################################
#
# ipb21.1.tcl v1.2
#
# :
#        RSS-.
#     :
#            IPB : 1.x - 2.0.4 c ssi.php -- ipb
#                              2.1.x - 2.2.x         -- ipb21
#            RSS:   2.0?                  -- rss
#             
#	  .
#
# : Kreon <*@gmail.com>
#
# : http://kreon.net.ru
# 
##############################################################################

namespace eval ipb21 {}

#   
bind PUB  -|-  {!forum}       ipb21::rsspublic
bind MSG  -|-  {!forum}        ipb21::rssprivate
#    
bind PUB  -|-  {!feeds}       ipb21::rsslistpub
bind MSG  -|-  {!feeds}        ipb21::rsslistmsg
#    
bind TIME -|-  {?0 * * * *}  ipb21::rssupdate
bind TIME -|-  {?5 * * * *}  ipb21::rssupdate
bind PUB  n  {!fcache}      ipb21::rssupdate

# 
#      
set ipb21(string_limit) 100
#       <description>
set ipb21(symlim) 150
#    
set ipb21(protect) 30
#  
set ipb21(encoding_to) cp1251
#    
set ipb21(httptimeout) 30
# 
set ipb21(ver) "1.2"
set ipb21(author) "Kreon"
set ipb21(client) {Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.7) Gecko/20040803 Firefox/0.9.3}
setudef flag nopubrss



#   -      
if { ![info exists egglib(ver)] } {
    putlog "***********************************************"
    putlog "             egglib_pub NOT FOUND !"
    putlog "   Download last version of egglib_pub here:"
    putlog "  http://eggdrop.org.ru/scripts/egglib_pub.zip"
    putlog "***********************************************"
    return
}

if { [expr {$egglib(ver) < 1.4}] } {
    putlog "***********************************************"
    putlog " YOUR VERSION OF egglib_pub IS TOO OLD !"
    putlog "   Download last version of egglib_pub here:"
    putlog "  http://eggdrop.org.ru/scripts/egglib_pub.zip"
    putlog "***********************************************"
    putlog " version installed : $egglib(ver)"
    putlog " version required: 1.4"
    return
}
array unset feed
#      
set feed(forum.eggdrop.org.ru) {
  URL=http://forum.eggdrop.org.ru/ssi.php?a=out&f=2,3,4,10,8&show=5&type=rss
  DATABASE=scripts/data/eggdrop_forum.temp
  CHANNELS=#@ #eggdrop
  CHANNELSD=#@ #eggdrop
  POSTNEWS=1
  POSTLIMIT=3
  PUBLIMIT=3
  MSGLIMIT=3
  ENCODINGFROM=cp1251
  VIANOTICE=1
  USEPROXY=0
  PROXY=some.good.proxy:8080
  TYPE=ipb
  POSTLAYOUT=\[\002 <feed> \002\] :: \037\037: \00303<forum>\003 :: \037 \037: \00303<title>\003 :: \00312\037<link>&view=getlastpost\003\037 :: \037 \037: \00303<author>\003 \@ \00303<date>\003
}
set feed(egghelp.ru) {
  URL=http://www.egghelp.ru/rss.php?feed=new
  DATABASE=scripts/data/egghelp.temp
  CHANNELS=#weird
  CHANNELSD=#@ #eggdrop
  POSTNEWS=1
  POSTLIMIT=3
  PUBLIMIT=3
  MSGLIMIT=5
  ENCODINGFROM=cp1251
  VIANOTICE=1
  USEPROXY=0
  PROXY=some.good.proxy:8080
  TYPE=egghelp
  POSTLAYOUT=\[\002 <feed> \002\] :: \037\037: \00303<title>\003 :: \00305<description>\003 \@ \00312\037<link>\003\037
}
#   
#set feed(_) {
#  URL=                           ;  RSS-
#  DATABASE=                      ;     ,     -  
#  CHANNELS=                      ;   ,     
#  CHANNELSD=                     ;   ,      
#  POSTNEWS=                      ; (1/0) -    
#  POSTLIMIT=                     ;      
#  PUBLIMIT=                      ;       
#  MSGLIMIT=                      ;       
#  ENCODINGFROM=                  ;  RSS-,    cp1251, utf-8 
#                                 ; (   &#;)
#  VIANOTICE=                     ; (1/0) -      
#  USEPROXY=                      ; (1/0) -     
#  PROXY=                         ; IP:PORT -    -   
#  TYPE=                          ;  , : ipb ( ssi.php), ipb21, rss
#  POSTLAYOUT=                    ;    ,  eggdrop  ,
#                                 ;  :
#                                 ; ipb - <feed> <publisher> <title> <link> <date> <author> <forum>
#                                 ; ipb21 - <feed> <publisher> <title> <link> <date> <author>* <starter>* <description>
#                                 ; rss - <feed> <publisher> <title> <link> <date> <description>
#}                                ; _______
#                                 ; * -    IPB  2.2  

proc ::ipb21::rssupdate {min hour day week year} {
	global ipb21 feed
  foreach id [array names feed] {
		set url          "0"
		set database     "0"
		set newsarch	 "0"
		set channels     "0"
		set postnews     "1"
		set postlimit    "3"
		set publimit     "3"
		set msglimit     "10"
		set postlayout   "<publisher> <news> <link>"
		set colour "\00307"
		foreach item [split $feed($id) \n] {
	    regsub -all -- {/\*.*\*/} $item {} item
	    regexp -nocase -- {^\s*URL=(.+?)\s*$} $item tmp url
	    regexp -nocase -- {^\s*DATABASE=(.+?)\s*$} $item tmp database
	    regexp -nocase -- {^\s*CHANNELS=(.+?)\s*$} $item tmp channels
	    regexp -nocase -- {^\s*POSTNEWS=(.+?)\s*$} $item tmp postnews
	    regexp -nocase -- {^\s*POSTLIMIT=(.+?)\s*$} $item tmp postlimit
	    regexp -nocase -- {^\s*PUBLIMIT=(.+?)\s*$} $item tmp publimit
	    regexp -nocase -- {^\s*MSGLIMIT=(.+?)\s*$} $item tmp msglimit
	    regexp -nocase -- {^\s*ENCODINGFROM=(.+?)\s*$} $item tmp encodingfrom
	    regexp -nocase -- {^\s*POSTLAYOUT=(.+?)\s*$} $item tmp postlayout
	    regexp -nocase -- {^\s*USEPROXY=(.+?)\s*$} $item tmp useproxy
	    regexp -nocase -- {^\s*TYPE=(.+?)\s*$} $item tmp type
	    regexp -nocase -- {^\s*PROXY=(.+?)\s*$} $item tmp proxy
		}
    if {($url == 0) || ($database == 0) || ($channels == 0)} {
			putlog "RSS: Warning: Couldn't load configuration for feed '$id'"
			continue
    }
		if {$postnews == 0} {
	    continue
		}
		regexp -- {^(\S+/)?.*$} $database tmp directory
		if {$directory != ""} {
	    if {![file isdirectory $directory]} {
				file mkdir $directory
	    }
		}
		if {[file exists $database]} {
      set archievednews [::egglib::readdata "$database"]
		} else { set archievednews "" }
		set count 0
		set data {}
		set limit $postlimit
		if {$limit < $publimit} {
	    set limit $publimit
		}
		if {$limit < $msglimit} {
	    set limit $msglimit
		}
		puthelp "PING :[unixtime]"
		set http_id [::egglib::http_init "ipb21::rsscheck_"]
		::egglib::http_set_agent $http_id $ipb21(client)
		::egglib::http_set_timeout $http_id $ipb21(httptimeout)
		if {$proxy != 0} {
			set proxy [split $proxy ":"]
		}
		if {$useproxy == 1} { ::egglib::http_set_proxy $http_id [lindex $proxy 0] [lindex $proxy 1] }
		::egglib::http_get $http_id $url [list $encodingfrom $limit $database $postlayout $postlimit $channels $id $colour $archievednews $type]
    }
}

proc ::ipb21::rsscheck_on_error {http_id html id} {
    putlog "error while updating data for feed $id"
}

proc ::ipb21::rsscheck_on_data {http_id html encodingfrom limit database postlayout postlimit channels id colour archievednews type} {
    global ipb21 rssnews sp_version
    set count 0
    set data ""
    foreach line [split $html \n] {
			append data $line
			incr count [regexp -all -nocase -- {</item>} $line]
			if {([regexp -nocase -- {</rss>} $line]) || ($count >= $limit)} {
	    	break
			}
    }
    ::egglib::http_cleanup $http_id
		if {[info exists sp_version]} {
			set data [encoding convertfrom $encodingfrom $data]
		} else {
			if {$encodingfrom != $ipb21(encoding_to)} {
				set data [encoding convertfrom $encodingfrom $data]
	  		set data [encoding convertto $ipb21(encoding_to) $data]
			}
		}
    set newnews ""
    set data [rsshtmlspecialchars $data]
    set publisher [rsspublisher $data]
		if {$encodingfrom == "utf-8"} {
			if {[catch {utf8ru $data} r]} {putlog "Error decoding UTF8: $r"; return} 
			set data [utf8ru $data]
		}
    set data [rssparse $data $type] 
    foreach {rssitem} [lsort -dictionary $data] {
    	if {[catch {lappend newnews [join "{$publisher} $rssnews($rssitem)" "[format %c 4]"]} r]} {putlog $rssnews($rssitem); putlog $r}
    }
    set count 0
    if {$archievednews == ""} {set caching 1}
  #     ,     -      ,      
  for {set i 0} {$i < [llength $newnews]} {incr i} {
  	if {([lsearch -exact $archievednews [lindex $newnews end-$i]] == -1)} {
  		lappend archievednews [lindex $newnews end-$i]
  		incr count
  	}
  }
	#       ...
	if { [llength $archievednews] > $ipb21(string_limit) } {
		set archievednews [lreplace $archievednews 0 [expr [llength $archievednews]-$ipb21(string_limit)-1]]
	}
	::egglib::writedata $database $archievednews

 	for {set i 0} {$i < $count && $i < $postlimit} {incr i} {
 		if {[info exists caching]} {break}
 		foreach channel [channels] {
 			if {[string equal -nocase $channels "ALL"] || [lsearch -exact [string tolower $channels] [string tolower $channel]] != -1} {
				
 				rssout $channel $channel 0 $id [lindex $archievednews end-$i] $postlayout
 			}
		}
	}
}
proc ::ipb21::rssout {nick chan where feed content outline} {
	set content [split $content "[format %c 4]"]
	regsub -all -- {<feed>} $outline $feed outline
	regsub -all -- {<publisher>} $outline [lindex $content 0] outline
	regsub -all -- {<title>} $outline [lindex $content 1] outline
	regsub -all -- {<link>} $outline [lindex $content 2] outline
	regsub -all -- {<date>} $outline [lindex $content 3] outline
	regsub -all -- {<author>} $outline [lindex $content 4] outline
	regsub -all -- {<forum>} $outline [lindex $content 5] outline
	regsub -all -- {<starter>} $outline [lindex $content 5] outline
	regsub -all -- {<description>} $outline [lindex $content 6] outline
	if {!$where} {
		if {$nick != $chan && [channel get $chan nopubrss]} { return }
  		egglib::out $nick $chan [subst -nocommands -novariables [join [split $outline]]]
 	 } else {
  		if {$nick == $chan} {egglib::outm $nick [subst -nocommands -novariables [join [split $outline]]]} else {egglib::outn $nick [subst -nocommands -novariables [join [split $outline]]]}
  	}
}
proc ::ipb21::rsspublisher {content} {
    set publisher {n/a}
    regsub -all -- {\n+|\s+|\t+|\r+} $content { } content
    regsub -all -- {\&} $content {\\\&} content
    regexp -nocase -- {<title>(.+?)</title>} $content tmp publisher
    regsub -nocase -- {<title>(.+?)</title>} $content {} content
    return $publisher
}


proc ::ipb21::rssparse {content type} {
   global rssnews ipb21
   array unset rssnews
   regsub -all -- {\n+|\s+|\t+|\r+} $content { } content
   regsub -all -- {\&} $content {\\\&} content
   set item 0
   switch -exact -- $type {
   	"ipb21" {
   		while {[regexp -nocase -- {<item(\s[^>]*?)?>(.+?)</item>} $content tmp tmp value]} {
				incr item
				set title  {n/a}
				regexp -nocase -- {<title>(.+?)</title>} $value tmp title
				set title [egglib::unhtml $title]
				set link {n/a}
				regexp -nocase -- {<link>(.+?)</link>} $value tmp link
				set date {n/a}
				regexp -nocase -- {<pubDate>(.+?)</pubDate>} $value tmp date
				catch {set date [clock format [clock scan [lrange $date 0 end-1]] -format "%d %B %Y, %H:%M"]}
				set desc {n/a}
				regexp -nocase -- {<description>(.+?)</description>} $value tmp desc
				regexp -nocase -- {<!\[CDATA\[(.+?)\]\]>} $desc tmp desc
				regsub -all -nocase -- {<br.*?>} $desc { } desc
				set desc [egglib::unhtml $desc]
				if {[string length $desc] > $ipb21(symlim)} then {set desc "[string range $desc 0 $ipb21(symlim)]..."}
				set author {n/a}
				regexp -nocase -- {<poster>(.+?)</poster>} $value tmp author
				set author [egglib::unhtml $author]
				set forum {n/a}
				regexp -nocase -- {<starter>(.+?)</starter>} $value tmp forum
				set forum [egglib::unhtml $forum]
				regsub -nocase -- {<item.*?>.+?</item>} $content {} content
				# 0 - , 1 - , 2 - , 3 - , 4 - , 5 - 
				set rssnews($item) "[list $title] [list $link] [list $date] [list $author] [list $forum] [list $desc]"
  		}
  	}
  	"ipb" {
			while {[regexp -nocase -- {<item(\s[^>]*?)?>(.+?)</item>} $content tmp tmp value]} {
				incr item
				set title  {n/a}
				regexp -nocase -- {<title>(.+?)</title>} $value tmp title
				set title [egglib::unhtml $title]
				set link {n/a}
				regexp -nocase -- {<link>(.+?)</link>} $value tmp link
				set author {n/a}
				regexp -nocase -- {showuser=(.+?)"\ target="_blank">(.+?)</a><br\ />Last Post} $value tmp tmp author
				set author [egglib::unhtml $author]
				set forum {n/a}
				regexp -nocase -- {showforum=(.+?)">(.+?)</a><br\ />Last Poster} $value tmp tmp forum
				set forum [egglib::unhtml $forum]
				set date {n/a}
				regexp -nocase -- {Last\ Post:\ (.+?)]]>} $value tmp date
				regsub -nocase -- {<item.*?>.+?</item>} $content {} content
				set rssnews($item) "[list $title] [list $link] [list $date] [list $author] [list $forum]"
			}
		}
  	egghelp {
			while {[regexp -nocase -- {<item(\s[^>]*?)?>(.+?)</item>} $content tmp tmp value]} {
				incr item
				set title  {n/a}
				regexp -nocase -- {<title>(.+?)</title>} $value tmp title
				set title [egglib::unhtml $title]
				set link {n/a}
				regexp -nocase -- {<link.*?>(.+?)</link>} $value tmp link
				set date {n/a}
				regexp -nocase -- {<pubDate>(.+?)</pubDate>} $value tmp date
				catch {set date [clock format [clock scan [lrange $date 0 end-1]] -format "%b %d %Y, %H:%M"]}
				set desc {n/a}
				regexp -nocase -- {<description>(.+?)</description>} $value tmp desc
				regsub -all -nocase -- {<br.*?>} $desc { } desc
				set desc [egglib::unhtml $desc]
				if {[string length $desc] > $ipb21(symlim)} then {set desc "[string range $desc 0 $ipb21(symlim)]..."}
				regsub -nocase -- {<item.*?>.+?</item>} $content {} content
				set rssnews($item) "[list $title] [list $link] {} {} {} [list $desc]"
			}
		}
  	default {
			while {[regexp -nocase -- {<item(\s[^>]*?)?>(.+?)</item>} $content tmp tmp value]} {
				incr item
				set title  {n/a}
				regexp -nocase -- {<title>(.+?)</title>} $value tmp title
				set title [egglib::unhtml $title]
				set link {n/a}
				regexp -nocase -- {<link.*?>(.+?)</link>} $value tmp link
				set date {n/a}
				regexp -nocase -- {<pubDate>(.+?)</pubDate>} $value tmp date
				catch {set date [clock format [clock scan [lrange $date 0 end-1]] -format "%b %d %Y, %H:%M"]}
				set desc {n/a}
				regexp -nocase -- {<description>(.+?)</description>} $value tmp desc
				regsub -all -nocase -- {<br.*?>} $desc { } desc
				set desc [egglib::unhtml $desc]
				if {[string length $desc] > $ipb21(symlim)} then {set desc "[string range $desc 0 $ipb21(symlim)]..."}
				regsub -nocase -- {<item.*?>.+?</item>} $content {} content
				set rssnews($item) "[list $title] [list $link] [list $date] {} {} [list $desc]"
			}
	  }
  }
   return [array names rssnews]
}

proc ::ipb21::rsshtmlspecialchars {content} {
set t [string map { &nbsp; \x20 &quot; \x22 &apos; \x27 &ndash; \x2D &lt; \x3C &gt; \x3E &amp; \x26 &tilde; \x7E &euro; \x80 &brvbar; \xA6 &copy; \xA9 &Auml; \xC4 &Ouml; \xD6 &Uuml; \xDC &szlig; \xDF &auml; \xE4 &ouml; \xF6 &uuml; \xFC &laquo; \\" &raquo; \\" } $content]
regsub -all -- {&\#8211;} $t {.} t
regsub -all -- {&\#33;} $t {!} t
regsub -all -- {&\#39;} $t {'} t
regsub -all -- {&quot;} $t {\"} t
regsub -all -- {&\#036;} $t {\$} t
	return $t
}

proc ::utf8ru {content} {
	global sp_version ipb21
	set content [string map {\[ \\[ \] \\] \\ \\\\} $content]
	regsub -all {&#(\d+);} $content {[format \\\u%04x \1]} t
	set t [subst -nocommands -novariables [subst -novariables $t]]
	if {![info exists sp_version]} {set t [encoding convertto $ipb21(encoding_to) $t]}
	return $t
}

proc ::ipb21::rsslistmsg {nick host hand arg} {
    regsub -all {\\} $arg {\\\\} arg
    rsslistpub $nick $host $hand $nick $arg
}

proc ::ipb21::rsslistpub {nick host hand chan arg} {
	global feed
	set line ""
	if {$nick != $chan} {
		foreach spewfeed [array names feed] {
			foreach item [split $feed($spewfeed) \n] {
				regsub -all -- {/\*.*\*/} $item {} item
				regexp -nocase -- {^\s*CHANNELS=(.+?)\s*$} $item tmp channels
				regexp -nocase -- {^\s*CHANNELSD=(.+?)\s*$} $item tmp channelsd
			}
			if {[info exists channels] && [lsearch [string tolower $channels] [string tolower $chan]] != -1 && [lsearch [string tolower $line] [string tolower $spewfeed]] eq -1} {lappend line $spewfeed; unset channels}
			if {[info exists channelsd] && [lsearch [string tolower $channelsd] [string tolower $chan]] != -1 && [lsearch [string tolower $line] [string tolower $spewfeed]] eq -1} {lappend line $spewfeed; unset channelsd}
		}
		if {[llength $line]} {
			egglib::outn $nick "  ,    $chan: [join [lsort -dictionary $line] ", "].    ,     ."	
		} else {
			egglib::outn $nick "     .   ,    : [join [lsort -dictionary [array names feed]] ", "]"	
		}
		return		
	}
	egglib::out $nick $nick "  : [join [lsort -dictionary [array names feed]] ", "]"
}

proc ::ipb21::rssprivate {nick host hand arg} {
    regsub -all {\\} $arg {\\\\} arg
    rsspublic $nick $host $hand $nick $arg
}

proc ::ipb21::rsspublic {nick host hand chan arg} {
    global feed ipb21
    regsub -all {\\} $arg {\\\\} arg
    if {$nick != $chan && [channel get $chan nopubrss]} {return}
    if {$arg == ""} { egglib::outh $nick $chan "!forum" "<> \[-(-2)\] \[ \]"; return}
    set spewfeed [lindex $arg 0]
    if {![isvalidfeed $spewfeed 1]} {
			egglib::outn $nick "  : [lsort -dictionary [array names feed]]"
			return 0
    }
    set spewfeed [isvalidfeed $spewfeed 2]
    set channels 0
    set channelsd 0
    foreach item [split $feed($spewfeed) \n] {
			regsub -all -- {/\*.*\*/} $item {} item
			regexp -nocase -- {^\s*CHANNELS=(.+?)\s*$} $item tmp channels
			regexp -nocase -- {^\s*CHANNELSD=(.+?)\s*$} $item tmp channelsd
    }
    if {$nick != $chan && [lsearch -exact [string tolower $channelsd] [string tolower $chan]] == -1 && [lsearch -exact [string tolower $channels] [string tolower $chan]] == -1 && ![string equal -nocase $channels "ALL"] && ![string equal -nocase $channelsd "ALL"]} {
			egglib::outn $nick "     ."
			return 0
    }
    set protect 30
    if {$nick != $chan && [info exists ipb21(flood)] && ![isop $nick $chan]} {
			set spam [expr [clock seconds] - $ipb21(flood)]
			if {$spam < $ipb21(protect)} {
				egglib::outn $nick "  !  [expr $protect - $spam]    ."
	    	return 0
			}
			set ipb21(flood) [clock seconds]
    }
    set vianotice 0
    foreach item [split $feed($spewfeed) \n] {
    	regsub -all -- {/\*.*\*/} $item {} item
    	regexp -nocase -- {^\s*DATABASE=(.+?)\s*$} $item tmp database
    	regexp -nocase -- {^\s*POSTLAYOUT=(.+?)\s*$} $item tmp postlayout
    	regexp -nocase -- {^\s*PUBLIMIT=(.+?)\s*$} $item tmp publimit
    	regexp -nocase -- {^\s*MSGLIMIT=(.+?)\s*$} $item tmp msglimit
			regexp -nocase -- {^\s*VIANOTICE=(.+?)\s*$} $item tmp vianotice
    }
    set arg [lrange $arg 1 end]
		set data [egglib::readdata $database]
		if {[llength $data] < 1} {egglib::out $nick $chan "    ... -.-";return}
    set qnum 1
    set qnum2 1
		if {[regexp -nocase -- {^-(\d+)$} [string trim [lindex $arg 0]] tr qnum] } {
			if {$qnum > $ipb21(string_limit)} {set qnum ipb21(string_limit)}
			set qnum2 $qnum
			set arg [lrange $arg 1 end]
		} elseif {[regexp -nocase -- {^-(\d+)-(\d+)$} [string trim [lindex $arg 0]] tr qnum qnum2] } {
			if {$nick == $chan} {
				if {[expr $qnum2 - $qnum] > $msglimit} {set qnum2 [expr $qnum + $msglimit]}
			} elseif {[expr $qnum2 - $qnum] > $publimit} {
				set qnum2 [expr $qnum + $publimit]
			}
			set arg [lrange $arg 1 end]
		}
		if {$arg != ""} {
			foreach line $data {
				if {[string match *$arg* $line]} {lappend q $line}
			}
			if {![info exists q]} {egglib::out $nick $chan "    \"$arg\"... -.-";return}
			#set q [lrange $q [expr $qnum2-1] [expr $qnum-1]]
			set q [lrange $q end-[expr $qnum2-1] end-[expr $qnum-1]]
		} else {
			set q [lrange $data end-[expr $qnum2-1] end-[expr $qnum-1]]
			#set q [lrange $data [expr $qnum2-1] [expr $qnum-1]]
		}
		if {[llength $q] < 1} {egglib::out $nick $chan "      ... -.-";return}
		set r ""
		foreach n $q {set r [linsert $r 0 $n]}
		foreach line $r {
			rssout $nick $chan $vianotice $spewfeed $line $postlayout
		}
		unset q n r
}

proc ::ipb21::isvalidfeed {keyword type} {
	global feed
	foreach id [array names feed] {
		if {[string match *[string tolower $keyword]* [string tolower $id]]} {
	    switch -exact -- $type {
				{1} {return 1}
				{2} {return $id}
	    }
	}
   }
   return 0
}
putlog "ipb21.1.tcl v$ipb21(ver) by $ipb21(author) initialised"